Style text inputs, checkboxes, toggle buttons and range sliders.
This page describes the grid's legacy theming system that was the default in v32 and before, for the benefit of applications that have not yet migrated to the Theming API. These themes are deprecated and will be removed in a future major version. You may want to visit the new theming docs or check out the migration guide.
Styling Text Inputs Copy Link
Text inputs can be styled with a combination of CSS variables and selectors:
.ag-theme-quartz {
--ag-borders-input: dotted 2px;
--ag-input-border-color: orange;
}
.ag-theme-quartz .ag-text-field-input {
background-color: rgb(255, 209, 123); /* light orange */
}
.ag-theme-quartz .ag-text-field-input::placeholder {
color: rgb(155, 101, 1); /* darker orange */
}import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
SideBarDef,
TextEditorModule,
Theme,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
class="ag-theme-quartz"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:theme="theme"
:defaultColDef="defaultColDef"
:sideBar="true"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "country" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const theme = ref<Theme | "legacy">("legacy");
const defaultColDef = ref<ColDef>({
editable: true,
filter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
theme,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.ag-theme-quartz,
.ag-theme-quartz-dark {
--ag-borders-input: dotted 2px;
--ag-input-border-color: orange;
}
.ag-theme-quartz .ag-text-field-input,
.ag-theme-quartz-dark .ag-text-field-input {
background-color: rgb(255, 209, 123); /* light orange */
}
.ag-theme-quartz .ag-text-field-input::placeholder,
.ag-theme-quartz-dark .ag-text-field-input::placeholder {
color: rgb(155, 101, 1); /* darker orange */
}
The CSS variables relevant to styling text inputs are:
Draw borders around inputs. Set this to a border style and thickness, e.g. solid 1px to enable borders, or none to disable borders. |
Colour for borders around inputs, if enabled with --ag-borders-input |
Draw borders around inputs when their content has failed validation. Set this to a border style and thickness, e.g. solid 2px to enable borders. Set to none to disable borders but ensure that you have added styles to differentiate invalid from valid inputs. |
The color for the border around invalid inputs, if enabled with --ag-borders-input-invalid |
The background color for a row with invalid editor status |
The color applied to form elements in an invalid state |
The border around disabled text inputs |
The background colour of disabled text inputs |
box shadow around focussed inputs |
Colour of the border around focussed inputs. Set to var(--ag-input-border-color) if you do not want to change the border colour on focus. |
Styling Checkboxes Copy Link
The default styles of the grid disable the browser's native checkbox widget and create a custom appearance using icon fonts (see below for how to disable this).
See the Custom Icons documentation for how to replace the checkbox icons - the icons used are checkbox-checked, checkbox-unchecked, checkbox-indeterminate.
The colours can be controlled using the following CSS Variables:
.ag-theme-quartz {
--ag-checkbox-background-color: yellow;
--ag-checkbox-checked-color: red;
--ag-checkbox-unchecked-color: darkred;
--ag-checkbox-indeterminate-color: grey;
}import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
SideBarDef,
TextEditorModule,
Theme,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
class="ag-theme-quartz"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:theme="theme"
:defaultColDef="defaultColDef"
:sideBar="true"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", hide: true },
{ field: "age", hide: true },
{ field: "country", hide: true },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const theme = ref<Theme | "legacy">("legacy");
const defaultColDef = ref<ColDef>({
editable: true,
filter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
theme,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.ag-theme-quartz,
.ag-theme-quartz-dark {
--ag-checkbox-background-color: yellow;
--ag-checkbox-checked-color: red;
--ag-checkbox-unchecked-color: darkred;
--ag-checkbox-indeterminate-color: grey;
}
Styling Radio Buttons Copy Link
Radio Buttons, such as those in the chart settings UI, are specialised checkboxes. They respond to the same colour variables as demonstrated above. They use the radio-button-on and radio-button-off icons.
Styling Toggle Buttons Copy Link
Toggle Buttons, such as the "Pivot Mode" toggle in the above example, are specialised checkboxes. They respond to the same checkbox colour variables. In addition, they expose a few more variables for advanced customisation:
size of the toggle button outer border |
colour of the toggle button outer border in its 'on' state |
colour of the toggle button's outer border in its 'off' state |
colour of the toggle button background in its 'on' state |
colour of the toggle button background in its 'off' state |
colour of the toggle button switch (the bit that slides from left to right) |
border colour of the toggle button switch (the bit that slides from left to right) |
width of the whole toggle button component |
height of the whole toggle button component |
Using Browser Native Checkboxes or Creating Your Own Copy Link
The default styles in ag-grid.css contain many CSS rules to implement the --ag-checkbox-* and --ag-toggle-button-* variables described above. If you want to use the browser's default UI or create your own then it's easier to start from a blank slate rather than attempting to override the default styles.
To achieve this, use the ag-grid-no-native-widgets.css CSS file instead of ag-grid.css.
Users of the Sass API can pass suppress-native-widget-styling: true to accomplish this.

Style text inputs, checkboxes, toggle buttons and range sliders.
This page describes the grid's legacy theming system that was the default in v32 and before, for the benefit of applications that have not yet migrated to the Theming API. These themes are deprecated and will be removed in a future major version. You may want to visit the new theming docs or check out the migration guide.
Styling Text Inputs Copy Link
Text inputs can be styled with a combination of CSS variables and selectors:
.ag-theme-quartz {
--ag-borders-input: dotted 2px;
--ag-input-border-color: orange;
}
.ag-theme-quartz .ag-text-field-input {
background-color: rgb(255, 209, 123); /* light orange */
}
.ag-theme-quartz .ag-text-field-input::placeholder {
color: rgb(155, 101, 1); /* darker orange */
}import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
SideBarDef,
TextEditorModule,
Theme,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
class="ag-theme-quartz"
[columnDefs]="columnDefs"
[theme]="theme"
[defaultColDef]="defaultColDef"
[sideBar]="true"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "country" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
theme: Theme | "legacy" = "legacy";
defaultColDef: ColDef = {
editable: true,
filter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
.ag-theme-quartz,
.ag-theme-quartz-dark {
--ag-borders-input: dotted 2px;
--ag-input-border-color: orange;
}
.ag-theme-quartz .ag-text-field-input,
.ag-theme-quartz-dark .ag-text-field-input {
background-color: rgb(255, 209, 123); /* light orange */
}
.ag-theme-quartz .ag-text-field-input::placeholder,
.ag-theme-quartz-dark .ag-text-field-input::placeholder {
color: rgb(155, 101, 1); /* darker orange */
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The CSS variables relevant to styling text inputs are:
Draw borders around inputs. Set this to a border style and thickness, e.g. solid 1px to enable borders, or none to disable borders. |
Colour for borders around inputs, if enabled with --ag-borders-input |
Draw borders around inputs when their content has failed validation. Set this to a border style and thickness, e.g. solid 2px to enable borders. Set to none to disable borders but ensure that you have added styles to differentiate invalid from valid inputs. |
The color for the border around invalid inputs, if enabled with --ag-borders-input-invalid |
The background color for a row with invalid editor status |
The color applied to form elements in an invalid state |
The border around disabled text inputs |
The background colour of disabled text inputs |
box shadow around focussed inputs |
Colour of the border around focussed inputs. Set to var(--ag-input-border-color) if you do not want to change the border colour on focus. |
Styling Checkboxes Copy Link
The default styles of the grid disable the browser's native checkbox widget and create a custom appearance using icon fonts (see below for how to disable this).
See the Custom Icons documentation for how to replace the checkbox icons - the icons used are checkbox-checked, checkbox-unchecked, checkbox-indeterminate.
The colours can be controlled using the following CSS Variables:
.ag-theme-quartz {
--ag-checkbox-background-color: yellow;
--ag-checkbox-checked-color: red;
--ag-checkbox-unchecked-color: darkred;
--ag-checkbox-indeterminate-color: grey;
}import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
SideBarDef,
TextEditorModule,
Theme,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
class="ag-theme-quartz"
[columnDefs]="columnDefs"
[theme]="theme"
[defaultColDef]="defaultColDef"
[sideBar]="true"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", hide: true },
{ field: "age", hide: true },
{ field: "country", hide: true },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
theme: Theme | "legacy" = "legacy";
defaultColDef: ColDef = {
editable: true,
filter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
.ag-theme-quartz,
.ag-theme-quartz-dark {
--ag-checkbox-background-color: yellow;
--ag-checkbox-checked-color: red;
--ag-checkbox-unchecked-color: darkred;
--ag-checkbox-indeterminate-color: grey;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Styling Radio Buttons Copy Link
Radio Buttons, such as those in the chart settings UI, are specialised checkboxes. They respond to the same colour variables as demonstrated above. They use the radio-button-on and radio-button-off icons.
Styling Toggle Buttons Copy Link
Toggle Buttons, such as the "Pivot Mode" toggle in the above example, are specialised checkboxes. They respond to the same checkbox colour variables. In addition, they expose a few more variables for advanced customisation:
size of the toggle button outer border |
colour of the toggle button outer border in its 'on' state |
colour of the toggle button's outer border in its 'off' state |
colour of the toggle button background in its 'on' state |
colour of the toggle button background in its 'off' state |
colour of the toggle button switch (the bit that slides from left to right) |
border colour of the toggle button switch (the bit that slides from left to right) |
width of the whole toggle button component |
height of the whole toggle button component |
Using Browser Native Checkboxes or Creating Your Own Copy Link
The default styles in ag-grid.css contain many CSS rules to implement the --ag-checkbox-* and --ag-toggle-button-* variables described above. If you want to use the browser's default UI or create your own then it's easier to start from a blank slate rather than attempting to override the default styles.
To achieve this, use the ag-grid-no-native-widgets.css CSS file instead of ag-grid.css.
Users of the Sass API can pass suppress-native-widget-styling: true to accomplish this.

Style text inputs, checkboxes, toggle buttons and range sliders.
This page describes the grid's legacy theming system that was the default in v32 and before, for the benefit of applications that have not yet migrated to the Theming API. These themes are deprecated and will be removed in a future major version. You may want to visit the new theming docs or check out the migration guide.
Styling Text Inputs Copy Link
Text inputs can be styled with a combination of CSS variables and selectors:
.ag-theme-quartz {
--ag-borders-input: dotted 2px;
--ag-input-border-color: orange;
}
.ag-theme-quartz .ag-text-field-input {
background-color: rgb(255, 209, 123); /* light orange */
}
.ag-theme-quartz .ag-text-field-input::placeholder {
color: rgb(155, 101, 1); /* darker orange */
}"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
SideBarDef,
TextEditorModule,
Theme,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", minWidth: 170 },
{ field: "age" },
{ field: "country" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
editable: true,
filter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle} className="ag-theme-quartz">
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
theme={"legacy"}
defaultColDef={defaultColDef}
sideBar={true}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.ag-theme-quartz,
.ag-theme-quartz-dark {
--ag-borders-input: dotted 2px;
--ag-input-border-color: orange;
}
.ag-theme-quartz .ag-text-field-input,
.ag-theme-quartz-dark .ag-text-field-input {
background-color: rgb(255, 209, 123); /* light orange */
}
.ag-theme-quartz .ag-text-field-input::placeholder,
.ag-theme-quartz-dark .ag-text-field-input::placeholder {
color: rgb(155, 101, 1); /* darker orange */
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; The CSS variables relevant to styling text inputs are:
Draw borders around inputs. Set this to a border style and thickness, e.g. solid 1px to enable borders, or none to disable borders. |
Colour for borders around inputs, if enabled with --ag-borders-input |
Draw borders around inputs when their content has failed validation. Set this to a border style and thickness, e.g. solid 2px to enable borders. Set to none to disable borders but ensure that you have added styles to differentiate invalid from valid inputs. |
The color for the border around invalid inputs, if enabled with --ag-borders-input-invalid |
The background color for a row with invalid editor status |
The color applied to form elements in an invalid state |
The border around disabled text inputs |
The background colour of disabled text inputs |
box shadow around focussed inputs |
Colour of the border around focussed inputs. Set to var(--ag-input-border-color) if you do not want to change the border colour on focus. |
Styling Checkboxes Copy Link
The default styles of the grid disable the browser's native checkbox widget and create a custom appearance using icon fonts (see below for how to disable this).
See the Custom Icons documentation for how to replace the checkbox icons - the icons used are checkbox-checked, checkbox-unchecked, checkbox-indeterminate.
The colours can be controlled using the following CSS Variables:
.ag-theme-quartz {
--ag-checkbox-background-color: yellow;
--ag-checkbox-checked-color: red;
--ag-checkbox-unchecked-color: darkred;
--ag-checkbox-indeterminate-color: grey;
}"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import "ag-grid-community/styles/ag-grid.css";
import "ag-grid-community/styles/ag-theme-quartz.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberEditorModule,
NumberFilterModule,
SideBarDef,
TextEditorModule,
Theme,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ColumnsToolPanelModule,
ContextMenuModule,
FiltersToolPanelModule,
PivotModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
NumberEditorModule,
TextEditorModule,
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
PivotModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", hide: true },
{ field: "age", hide: true },
{ field: "country", hide: true },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
editable: true,
filter: true,
enableRowGroup: true,
enablePivot: true,
enableValue: true,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle} className="ag-theme-quartz">
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
theme={"legacy"}
defaultColDef={defaultColDef}
sideBar={true}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.ag-theme-quartz,
.ag-theme-quartz-dark {
--ag-checkbox-background-color: yellow;
--ag-checkbox-checked-color: red;
--ag-checkbox-unchecked-color: darkred;
--ag-checkbox-indeterminate-color: grey;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; Styling Radio Buttons Copy Link
Radio Buttons, such as those in the chart settings UI, are specialised checkboxes. They respond to the same colour variables as demonstrated above. They use the radio-button-on and radio-button-off icons.
Styling Toggle Buttons Copy Link
Toggle Buttons, such as the "Pivot Mode" toggle in the above example, are specialised checkboxes. They respond to the same checkbox colour variables. In addition, they expose a few more variables for advanced customisation:
size of the toggle button outer border |
colour of the toggle button outer border in its 'on' state |
colour of the toggle button's outer border in its 'off' state |
colour of the toggle button background in its 'on' state |
colour of the toggle button background in its 'off' state |
colour of the toggle button switch (the bit that slides from left to right) |
border colour of the toggle button switch (the bit that slides from left to right) |
width of the whole toggle button component |
height of the whole toggle button component |
Using Browser Native Checkboxes or Creating Your Own Copy Link
The default styles in ag-grid.css contain many CSS rules to implement the --ag-checkbox-* and --ag-toggle-button-* variables described above. If you want to use the browser's default UI or create your own then it's easier to start from a blank slate rather than attempting to override the default styles.
To achieve this, use the ag-grid-no-native-widgets.css CSS file instead of ag-grid.css.
Users of the Sass API can pass suppress-native-widget-styling: true to accomplish this.